/*
   Dama 1.0: Programma di Dama a 2 giocatori
   Copyright (C) 2005  Destroyer

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/

public class Dama{
	
	private int x,y,mpX,mpY;
	private int currentX,currentY;
    private int state,win,prese;
	protected Quadrato[][] q;
    private boolean qsign,active,mpresa;
    private Mosse mosse;
	
	public Dama(){
        
        mosse= new Mosse();

    q=new Quadrato[8][8];

	for(int i=0;i<q.length;i++)
	for(int j=0;j<q.length;j++){
	  if((i+1+j+1)%2==0)
	    q[i][j]=new Quadrato(true);
      else
	    q[i][j]=new Quadrato(false);        
        }   
	start();
		}
	
	 public void invTav(){
	 	
	for(int i=0;i<q.length;i++)
	for(int j=0;j<q.length;j++){
		q[i][j].setType(!q[i][j].GetType());
		}
	 	
	 	}
	
	 public void start(){

		currentX=currentY=y=x=-1;
        state=Define.BIANCO;
	 
	 int c=Define.NERO;
	 boolean cs=q[0][0].GetType();	
     for(int j=0;j<q.length;j++){
	 for(int i=0;i<q.length;i++){	  

	  if (j==3) c=Define.BIANCO;
	    
      if ((cs==q[i][j].GetType())&&(j!=3)&&(j!=4))
	    q[i][j].setPCol(c);
	    
	 }}
	 	segnaBloccate();
	 	active=true;
	 	mosse.clear();
	 }   
	
	public void reset(){
		unsignedAll();	    	
	    resetBloccate();
     
     for(int j=0;j<q.length;j++)
	 for(int i=0;i<q.length;i++)
	     q[i][j].reset();		
		start();
		}
	
	public void annulla(){
		
		Mosse.Mossa ms=mosse.getLastAndRemove();
		
		if (ms==null) return;
		
		active=true;
		
		if (ms.rem){
			
			q[ms.fx][ms.fy].setPCol(ms.color);
			q[ms.fx][ms.fy].setDama(ms.dama);
			state=ms.state;
			annulla();
			}else{
			q[ms.tx][ms.ty].reset();			
			
			q[ms.fx][ms.fy].setPCol(ms.color);
			q[ms.fx][ms.fy].setDama(ms.dama);
			state=ms.state;				
			
			unsignedAll();	    	
	    	resetBloccate();
	        findGnam();
	         ckNM();
	         ckPR();
	         ckVT();	         
	         ckVP();
	        segnaBloccate();
	        ClearSetXY();	
			}
		
		}    
    
    public int getState(){
    	return state;}
    
    public void invState(){
    	if (state==Define.BIANCO)
    	state=Define.NERO;
    	else state=Define.BIANCO;}	
    
	public boolean isValidMove(){
   
    if (!isSetXY()) return false;
    if (!((currentX>=0)&&(currentX<8)&&(currentY>=0)&&(currentY<8)))
     return false;
    if (q[currentX][currentY].GetType()!=q[0][0].GetType()) return false; 
    if (q[currentX][currentY].GetPCol()!=Define.VUOTO) return false;
    
    if (!qsign){
    	
    if (((state==Define.BIANCO)||(q[x][y].isDama()))&&(currentY==y-1)&&((currentX==x-1)||(currentX==x+1))) return true;
    if (((state==Define.NERO)||(q[x][y].isDama()))&&(currentY==y+1)&&((currentX==x-1)||(currentX==x+1))) return true; 
    } else { 

    if (((state==Define.BIANCO)||(q[x][y].isDama()))&&(currentY==y-2)&&((currentX==x-2)&&(q[x-1][y-1].GetPCol()!=Define.VUOTO)&&(q[x-1][y-1].GetPCol()!=state)&&((!q[x-1][y-1].isDama())||(q[x][y].isDama()))&&(q[x][y].getTopLeft())||(currentX==x+2)&&(q[x+1][y-1].GetPCol()!=Define.VUOTO)&&(q[x+1][y-1].GetPCol()!=state)&&((!q[x+1][y-1].isDama())||(q[x][y].isDama()))&&(q[x][y].getTopRight()))) return true;
    if (((state==Define.NERO)||(q[x][y].isDama()))&&(currentY==y+2)&&((currentX==x-2)&&(q[x-1][y+1].GetPCol()!=Define.VUOTO)&&(q[x-1][y+1].GetPCol()!=state)&&((!q[x-1][y+1].isDama())||(q[x][y].isDama()))&&(q[x][y].getBottomLeft())||(currentX==x+2)&&(q[x+1][y+1].GetPCol()!=Define.VUOTO)&&(q[x+1][y+1].GetPCol()!=state)&&((!q[x+1][y+1].isDama())||(q[x][y].isDama()))&&(q[x][y].getBottomRight()))) return true;    
    }


	return false;
		}    
	    

	  private void findGnam(){
	
	reset4();
	        
	for(int cX=0;cX<q.length;cX++)
	for(int cY=0;cY<q.length;cY++){	  	
    
    if ((state==Define.BIANCO)||(q[cX][cY].isDama())&&(q[cX][cY].GetPCol()==state)){
    	if (checkGnam(cX,cY,cX+2,cY-2)){

    	q[cX][cY].setTopRight();    
    	qsign=true;
    	prese++;
    	}
    	if (checkGnam(cX,cY,cX-2,cY-2)){

    	q[cX][cY].setTopLeft();    
    	qsign=true;
    	prese++;
    	}    	
    	}
    
    if ((state==Define.NERO)||(q[cX][cY].isDama())&&(q[cX][cY].GetPCol()==state)){
      	if (checkGnam(cX,cY,cX+2,cY+2)){

    	q[cX][cY].setBottomRight();    
    	qsign=true;
    	prese++;
    	}
      	if (checkGnam(cX,cY,cX-2,cY+2)){

    	q[cX][cY].setBottomLeft();    
    	qsign=true;
    	prese++;
    	}    	
    	}
    }
	  	
	  
	  	}
	  	

	
	private boolean isGnamXY(int cX,int cY){

    if ((state==Define.BIANCO)||(q[cX][cY].isDama())&&(q[cX][cY].GetPCol()==state)){
    	if ((checkGnam(cX,cY,cX-2,cY-2))
    	  ||(checkGnam(cX,cY,cX+2,cY-2))){
   
    	qsign=true;
    	}}
    
    if ((state==Define.NERO)||(q[cX][cY].isDama())&&(q[cX][cY].GetPCol()==state)){
      	
      	if ((checkGnam(cX,cY,cX-2,cY+2))
    	  ||(checkGnam(cX,cY,cX+2,cY+2))){
   
    	qsign=true;
    	}}
		
		return qsign;}
	

    		
	private boolean checkGnam(int fx,int fy,int tx,int ty){
		
		if (!((fx>=0)&&(fx<8)&&(fy>=0)&&(fy<8))) return false;
		if (!((tx>=0)&&(tx<8)&&(ty>=0)&&(ty<8))) return false;		
		
		int mx=(fx+tx)/2;
		int my=(fy+ty)/2;
		
        if ((q[fx][fy].GetPCol()==state)&&
            (q[mx][my].GetPCol()!=Define.VUOTO)&&
            (q[mx][my].GetPCol()!=state)&&
            ((!q[mx][my].isDama())||(q[fx][fy].isDama()))&&
            (q[tx][ty].GetPCol()==Define.VUOTO)) return true;
        
        return false;
		}
		
	    
	public boolean isSigned(){
		return qsign;}
		
	public void unsignedAll(){

	qsign=false;
    prese=0;
		}	
	
	public boolean SelectQ(int x,int y){
	    	if (((x>=0)&&(x<8)&&(y>=0)&&(y<8))&&(isValidQ()))
	    	   if (q[x][y].GetPCol()==state){

	    	    	this.x=x;
	    	    	this.y=y;  
    
	    	       return true;}
	    	this.x=-1;
	    	this.y=-1;
	    	return false;
	    	}
	   
	    public boolean isSetXY(){
	    	if ((x!=-1)&&(y!=-1)) return true; 
	    	else return false;}
	    	
	    public void ClearSetXY(){
	    	x=y=-1;
	    	}
	    
	    public void segnaBloccate(){
	
	if (qsign) return;
	    	
	for(int cX=0;cX<q.length;cX++)
	for(int cY=0;cY<q.length;cY++){	
	  	
 if (q[cX][cY].GetPCol()==state){
 	
 	if (!q[cX][cY].isDama()){
    
    if (state==Define.BIANCO){
   
     if ((checkBlock(cX,cY,cX-1,cY-1))&&(checkBlock(cX,cY,cX+1,cY-1)))
            q[cX][cY].setBState(true);
             
            }
    if (state==Define.NERO){
            
     if ((checkBlock(cX,cY,cX-1,cY+1))&&(checkBlock(cX,cY,cX+1,cY+1)))
            q[cX][cY].setBState(true);
             
            } }else{
            
     if ((checkBlock(cX,cY,cX-1,cY+1))&&(checkBlock(cX,cY,cX+1,cY+1))&&(checkBlock(cX,cY,cX-1,cY-1))&&(checkBlock(cX,cY,cX+1,cY-1)))
            q[cX][cY].setBState(true);
             
            } }}
            	    	
	    	}
	    	
	private boolean checkBlock(int fx,int fy,int tx,int ty){
	
	    if (!((fx>=0)&&(fx<8)&&(fy>=0)&&(fy<8))) return false;
		if (!((tx>=0)&&(tx<8)&&(ty>=0)&&(ty<8))) return true;
	
	    if (q[tx][ty].GetPCol()!=Define.VUOTO) return true;
	    else return false;
           
		}    	
	    	
	    public void resetBloccate(){
	    	
	for(int cX=0;cX<q.length;cX++)
	for(int cY=0;cY<q.length;cY++){	
        q[cX][cY].setBState(false);    
            }
	    	}
	    	
	    public boolean isActive(){
	    	return active;
	    	}		
	    
	    public String theWinner(){
	    	if (win==Define.BIANCO){return "BIANCO";}
	    	else {return "NERO";}
	    	
	    	}
	    	
	    public void moveTo(){
	   	if(isValidMove()){
            mosse.addMove(x,y,currentX,currentY,state,state,q[x][y].isDama());
            ctrlGnam();
	   		unsignedAll();
	    	q[currentX][currentY].setPCol(state);
	    	q[currentX][currentY].setDama(q[x][y].isDama());
	    	q[x][y].reset();
	    	ctrlDama();
	    	if (!((isGnamXY(currentX,currentY))&&(lastIsGnam())&&(!fromPtoD()))){ 

	   		unsignedAll();	    	
	    	invState();
	        resetBloccate();
	        findGnam();
             mPresaOff();

	         ckNM(); 
	         ckPR();  
	         ckVT();  	         
	         ckVP(); 

	        segnaBloccate();
	        ctrlEnd();
	        } else {
             mPresaOn();
             contaPrese();
	         ckNM(); 
	         ckPR(); 
	         ckVT(); 	         
	         ckVP();
	        	
	        	} 
	        }
	        ClearSetXY();
	    	}	
	     
	      private void mPresaOn(){
	      	 mpresa=true;
    	   	 mpX=currentX;
    	   	 mpY=currentY;	
	      	}
	     
	      private void mPresaOff(){
	      	 mpresa=false;
    	   	 mpX=-1;
    	   	 mpY=-1;	
	      	
	      	}
	            
	      private void contaPrese(){
    
	for(int cX=0;cX<q.length;cX++)
	for(int cY=0;cY<q.length;cY++){	  	
    
    if (mpresa){
    	cX=mpX;
    	cY=mpY;
    	}
    	
    if ((state==Define.BIANCO)||(q[cX][cY].isDama())&&(q[cX][cY].GetPCol()==state)){
    	if (checkGnam(cX,cY,cX+2,cY-2)){

     	prese++;
    	}
    	if (checkGnam(cX,cY,cX-2,cY-2)){

    	prese++;
    	}    	
    	}
    
    if ((state==Define.NERO)||(q[cX][cY].isDama())&&(q[cX][cY].GetPCol()==state)){
      	if (checkGnam(cX,cY,cX+2,cY+2)){

    	prese++;
    	}
      	if (checkGnam(cX,cY,cX-2,cY+2)){

    	prese++;
    	}    	
    	}
        if (mpresa){
    	cX=q.length;
    	cY=q.length;
    	}
    }

          }
	  
  	  	
	      private void ckPR(){
	  	  	
	  	  	if (prese<=1) return;
	  	  	
	  	boolean b=false;
	  	  	
	for(int cX=0;cX<q.length;cX++)
	for(int cY=0;cY<q.length;cY++){
		        if (mpresa){
    	cX=mpX;
    	cY=mpY;
    	}
		if (q[cX][cY].isSigned() && q[cX][cY].isDama()){
		b=true;
		break;} 
	        if (mpresa){
    	cX=q.length;
    	cY=q.length;
    	}
    	}
		
	if (b){
	for(int cX=0;cX<q.length;cX++)
	for(int cY=0;cY<q.length;cY++){
		        if (mpresa){
    	cX=mpX;
    	cY=mpY;
    	}	
		if (q[cX][cY].isSigned() && !q[cX][cY].isDama())
		q[cX][cY].reset4(); 	
		        if (mpresa){
    	cX=q.length;
    	cY=q.length;
    	}
		}
		}		
		      	
	      	}
	      	
	      private void ckVT(){
	  	  	
	  	  	if (prese<=1) return;
	    
	int max=0;

		
    for(int cX=0;cX<q.length;cX++)
	for(int cY=0;cY<q.length;cY++){	  	
            if (mpresa){
    	cX=mpX;
    	cY=mpY;
    	}
    int tl=0,tr=0,bl=0,br=0;
    	
    int st=q[cX][cY].GetPCol();
    boolean dm=q[cX][cY].isDama();
    
    if ((state==Define.BIANCO)||(q[cX][cY].isDama())&&(q[cX][cY].GetPCol()==state)){
    	if (checkGnam(cX,cY,cX+2,cY-2)){

    	tr=checkGnam4RD(cX+2,cY-2,st,dm,cX,cY);
    	if (q[cX+1][cY-1].isDama()) tr++;    	}
    	
    	if (checkGnam(cX,cY,cX-2,cY-2)){

    	tl=checkGnam4RD(cX-2,cY-2,st,dm,cX,cY); 
        if (q[cX-1][cY-1].isDama()) tl++;    	}    	
    	}
    
    if ((state==Define.NERO)||(q[cX][cY].isDama())&&(q[cX][cY].GetPCol()==state)){
      	if (checkGnam(cX,cY,cX+2,cY+2)){
 
    	br=checkGnam4RD(cX+2,cY+2,st,dm,cX,cY); 
        if (q[cX+1][cY+1].isDama()) br++;    	}
      	
      	if (checkGnam(cX,cY,cX-2,cY+2)){
   
    	bl=checkGnam4RD(cX-2,cY+2,st,dm,cX,cY); 
        if (q[cX-1][cY+1].isDama()) bl++;    	}    	
    	}
            if (mpresa){
    	cX=q.length;
    	cY=q.length;
    	}
    if (max<returnMax(tl,tr,bl,br)) max=returnMax(tl,tr,bl,br) ;
    }
 	

    

    for(int cX=0;cX<q.length;cX++)
	for(int cY=0;cY<q.length;cY++){	  	
            if (mpresa){
    	cX=mpX;
    	cY=mpY;
    	}
        int tl=0,tr=0,bl=0,br=0;	
    int st=q[cX][cY].GetPCol();
    boolean dm=q[cX][cY].isDama();
    
    if ((state==Define.BIANCO)||(q[cX][cY].isDama())&&(q[cX][cY].GetPCol()==state)){
    	if (checkGnam(cX,cY,cX+2,cY-2)){
    
     	tr=checkGnam4RD(cX+2,cY-2,st,dm,cX,cY);
        if (q[cX+1][cY-1].isDama()) tr++;
    if (tr<max) q[cX][cY].unsetTopRight();    	 
    	}
    	if (checkGnam(cX,cY,cX-2,cY-2)){
  
    	tl=checkGnam4RD(cX-2,cY-2,st,dm,cX,cY);
        if (q[cX-1][cY-1].isDama()) tl++; 
    if (tl<max) q[cX][cY].unsetTopLeft(); 
    	}    	
    	}
    
    if ((state==Define.NERO)||(q[cX][cY].isDama())&&(q[cX][cY].GetPCol()==state)){
      	if (checkGnam(cX,cY,cX+2,cY+2)){
   
    	br=checkGnam4RD(cX+2,cY+2,st,dm,cX,cY);
        if (q[cX+1][cY+1].isDama()) br++; 
    if (br<max) q[cX][cY].unsetBottomRight(); 
    	}
      	if (checkGnam(cX,cY,cX-2,cY+2)){
 
     	bl=checkGnam4RD(cX-2,cY+2,st,dm,cX,cY); 
        if (q[cX-1][cY+1].isDama()) bl++;
    if (bl<max) q[cX][cY].unsetBottomLeft(); 
    	}    	
    	}
            if (mpresa){
    	cX=q.length;
    	cY=q.length;
    	}
    }	  	  	
	  	  		      	
	      	}
	      		      	         
	      private void ckVP(){
	  	  	
	  	  	if (prese<=1) return;
	  	  	
	  	boolean b=false;
	  	  	
	for(int cX=0;cX<q.length;cX++)
	for(int cY=0;cY<q.length;cY++){
		        if (mpresa){
    	cX=mpX;
    	cY=mpY;
    	}
		if (q[cX][cY].getTopLeft() && q[cX-1][cY-1].isDama() ||
		    q[cX][cY].getTopRight() && q[cX+1][cY-1].isDama() ||
		    q[cX][cY].getBottomLeft() && q[cX-1][cY+1].isDama() ||
		    q[cX][cY].getBottomRight() && q[cX+1][cY+1].isDama()){
		b=true;
		break;} 
	        if (mpresa){
    	cX=q.length;
    	cY=q.length;
    	}
    	}
		
	if (b){
	for(int cX=0;cX<q.length;cX++)
	for(int cY=0;cY<q.length;cY++){	
		        if (mpresa){
    	cX=mpX;
    	cY=mpY;
    	}
		if (q[cX][cY].getTopLeft() && !q[cX-1][cY-1].isDama())
		q[cX][cY].unsetTopLeft();
		if (q[cX][cY].getTopRight() && !q[cX+1][cY-1].isDama())
		q[cX][cY].unsetTopRight();		
		if (q[cX][cY].getBottomLeft() && !q[cX-1][cY+1].isDama())
		q[cX][cY].unsetBottomLeft();		
		if (q[cX][cY].getBottomRight() && !q[cX+1][cY+1].isDama())	  	  		      	
	    q[cX][cY].unsetBottomRight(); 	
	      	
	           if (mpresa){
    	cX=q.length;
    	cY=q.length;
    	}
    	}
	 }}
	      private void reset4(){
	      	
	for(int cX=0;cX<q.length;cX++)
	for(int cY=0;cY<q.length;cY++)	
         q[cX][cY].reset4();
	      	
	      	}
	  
	  private int returnMax(int a,int b,int c,int d){
	  	
	  	if (a<b){
	  		if (b>c){
	  		if (b>d) return b;
	  	    else return d;
	  	    }
	  		else{
	  		if (c>d) return c;
	  		else return d;	  		
	  	    }
	  		}else{
	  		if (a>c){
	  		if (a>d) return a;
	  	    else return d;
	  	    }
	  		else{
	  		if (c>d) return c;
	  		else return d;	  		
	  	    }  	    
	  	    }
	  	}
	  
	  
	  private void ckNM(){

	int max=0;
		
    for(int cX=0;cX<q.length;cX++)
	for(int cY=0;cY<q.length;cY++){	  	
        if (mpresa){
    	cX=mpX;
    	cY=mpY;
    	} 
        int tl=0,tr=0,bl=0,br=0;
          
    int st=q[cX][cY].GetPCol();
    boolean dm=q[cX][cY].isDama();

    if ((state==Define.BIANCO)||(q[cX][cY].isDama())&&(q[cX][cY].GetPCol()==state)){
    	if (checkGnam(cX,cY,cX+2,cY-2)){

    	q[cX][cY].setTopRight();    
    	tr=1+checkGnam4R(cX+2,cY-2,st,dm,cX,cY); 
    	}
    	if (checkGnam(cX,cY,cX-2,cY-2)){

    	q[cX][cY].setTopLeft();    
    	tl=1+checkGnam4R(cX-2,cY-2,st,dm,cX,cY); 
    	}    	
    	}
    
    if ((state==Define.NERO)||(q[cX][cY].isDama())&&(q[cX][cY].GetPCol()==state)){
      	if (checkGnam(cX,cY,cX+2,cY+2)){

    	q[cX][cY].setBottomRight();    
    	br=1+checkGnam4R(cX+2,cY+2,st,dm,cX,cY); 
    	}
      	if (checkGnam(cX,cY,cX-2,cY+2)){

    	q[cX][cY].setBottomLeft();    
    	bl=1+checkGnam4R(cX-2,cY+2,st,dm,cX,cY); 
    	}    	
    	}
            if (mpresa){
    	cX=q.length;
    	cY=q.length;
    	}
        if (max<returnMax(tl,tr,bl,br)) max=returnMax(tl,tr,bl,br) ;
   	}

 	if (prese<=1) return;
 	  	  		


    for(int cX=0;cX<q.length;cX++)
	for(int cY=0;cY<q.length;cY++){	  	
            if (mpresa){
    	cX=mpX;
    	cY=mpY;
    	}
        int tl=0,tr=0,bl=0,br=0;
    int st=q[cX][cY].GetPCol();
    boolean dm=q[cX][cY].isDama();
    
    if ((state==Define.BIANCO)||(q[cX][cY].isDama())&&(q[cX][cY].GetPCol()==state)){
    	if (checkGnam(cX,cY,cX+2,cY-2)){
    
     	tr=1+checkGnam4R(cX+2,cY-2,st,dm,cX,cY);
    if (tr<max) q[cX][cY].unsetTopRight();    	 
    	}
    	if (checkGnam(cX,cY,cX-2,cY-2)){
  
    	tl=1+checkGnam4R(cX-2,cY-2,st,dm,cX,cY); 
    if (tl<max) q[cX][cY].unsetTopLeft(); 
    	}    	
    	}
    
    if ((state==Define.NERO)||(q[cX][cY].isDama())&&(q[cX][cY].GetPCol()==state)){
      	if (checkGnam(cX,cY,cX+2,cY+2)){
   
    	br=1+checkGnam4R(cX+2,cY+2,st,dm,cX,cY); 
    if (br<max) q[cX][cY].unsetBottomRight(); 
    	}
      	if (checkGnam(cX,cY,cX-2,cY+2)){
 
     	bl=1+checkGnam4R(cX-2,cY+2,st,dm,cX,cY); 
    if (bl<max) q[cX][cY].unsetBottomLeft(); 
    	}    	
    	}
            if (mpresa){
    	cX=q.length;
    	cY=q.length;
    	}
    	}
 	
 	}
	  

	 private int checkGnam4RD(int cX,int cY,int st,boolean dm,int pX,int pY){
	
	int tl,tr,bl,br;
	
	tl=tr=bl=br=0;   	
   
    if ((state==Define.BIANCO)||(dm)&&(st==state)){
    	if (checkGnamS(cX,cY,cX+2,cY-2,st,dm,pX,pY)){
  
    	tr=checkGnam4RD(cX+2,cY-2,st,dm,cX,cY);    
        if (q[cX+1][cY-1].isDama()) tr++;
    	}
    	if (checkGnamS(cX,cY,cX-2,cY-2,st,dm,pX,pY)){

    	tl=checkGnam4RD(cX-2,cY-2,st,dm,cX,cY); 
        if (q[cX-1][cY-1].isDama()) tl++;
    	}    	
    	}
    
    if ((state==Define.NERO)||(dm)&&(st==state)){
      	if (checkGnamS(cX,cY,cX+2,cY+2,st,dm,pX,pY)){

    	br=checkGnam4RD(cX+2,cY+2,st,dm,cX,cY);     
        if (q[cX+1][cY+1].isDama()) br++;
    	}
      	if (checkGnamS(cX,cY,cX-2,cY+2,st,dm,pX,pY)){
 
    	bl=checkGnam4RD(cX-2,cY+2,st,dm,cX,cY);     
        if (q[cX-1][cY+1].isDama()) bl++;
    	}    	
    	}
 	return returnMax(tl,tr,bl,br);	  	
	  	} 
	
	 private int checkGnam4R(int cX,int cY,int st,boolean dm,int pX,int pY){
	
	int tl,tr,bl,br;
	
	tl=tr=bl=br=0;   	
   
    if ((state==Define.BIANCO)||(dm)&&(st==state)){
    	if (checkGnamS(cX,cY,cX+2,cY-2,st,dm,pX,pY)){

    	q[cX][cY].setTopRight();
    	tr=1+checkGnam4R(cX+2,cY-2,st,dm,cX,cY);    
    	}
    	if (checkGnamS(cX,cY,cX-2,cY-2,st,dm,pX,pY)){

    	q[cX][cY].setTopLeft(); 
    	tl=1+checkGnam4R(cX-2,cY-2,st,dm,cX,cY); 
    	}    	
    	}
    
    if ((state==Define.NERO)||(dm)&&(st==state)){
      	if (checkGnamS(cX,cY,cX+2,cY+2,st,dm,pX,pY)){

    	q[cX][cY].setBottomRight();
    	br=1+checkGnam4R(cX+2,cY+2,st,dm,cX,cY);     
    	}
      	if (checkGnamS(cX,cY,cX-2,cY+2,st,dm,pX,pY)){

    	q[cX][cY].setBottomLeft();
    	bl=1+checkGnam4R(cX-2,cY+2,st,dm,cX,cY);     
    	}    	
    	}
 	return returnMax(tl,tr,bl,br);	  	
	  	} 
	  	
	  	private boolean checkGnamS(int fx,int fy,int tx,int ty,int st,boolean dm,int pX,int pY){
	
		if (!((fx>=0)&&(fx<8)&&(fy>=0)&&(fy<8))) return false;
		if (!((tx>=0)&&(tx<8)&&(ty>=0)&&(ty<8))) return false;		
		if ((tx==pX)&&(ty==pY)) return false;
		
		int mx=(fx+tx)/2;
		int my=(fy+ty)/2;
		
        if ((st==state)&&
            (q[mx][my].GetPCol()!=Define.VUOTO)&&
            (q[mx][my].GetPCol()!=state)&&
            ((!q[mx][my].isDama())||(dm))&&
            ((q[tx][ty].GetPCol()==Define.VUOTO)||
            (tx==x && ty==y && dm))) return true;
        
        return false;
		}
	  
	  
	  private void ctrlEnd(){
	  	
	  	if (isEnd()){
	  		if (state==Define.BIANCO) win=Define.NERO;
	  		else win=Define.BIANCO;
	  		active=false;
	  		}
	  	
	  	}
	  
	  private boolean isEnd(){
    
     
	for(int cX=0;cX<q.length;cX++)
	for(int cY=0;cY<q.length;cY++){	
        if (q[cX][cY].GetPCol()==state){
        
        if (!q[cX][cY].isBlocked()) return false;  
        	
        }}
	  	
	  	return true;}
	  
	  private boolean lastIsGnam(){
	  	
	  	if ((mosse.getLast().rem)&&(mosse.getLast().color!=state))
            return true;
            else return false;	  	
	  	}
	  
	  private boolean fromPtoD(){
	  
	    if (mosse.getLast().rem){
	  	if ((q[currentX][currentY].isDama())&&
	  		(mosse.getPLast().state==state)&&
	  		(!mosse.getPLast().dama))
	  	    return true;	    	
	    	}else{	
	  	if ((q[currentX][currentY].isDama())&&
	  		(mosse.getLast().state==state)&&
	  		(!mosse.getLast().dama))
	  	    return true;
	  	    }
	  	return false;    
	  	}
	   
	  private void ctrlGnam(){
	  
	  	if (qsign){
	    mosse.addRemove((currentX+x)/2,(currentY+y)/2,q[(currentX+x)/2][(currentY+y)/2].GetPCol(),state,q[(currentX+x)/2][(currentY+y)/2].isDama());
	    q[(currentX+x)/2][(currentY+y)/2].setPCol(Define.VUOTO);
	    }	
	  	}
	  	
	  private void ctrlDama(){
	  
	  	if ((state==Define.BIANCO)&&(currentY==0)&&(!q[currentX][currentY].isDama()))
	    q[currentX][currentY].setDama(true);

	  	if ((state==Define.NERO)&&(currentY==7)&&(!q[currentX][currentY].isDama()))
	    q[currentX][currentY].setDama(true);
	    	   		
	  	}
	  		  	  
	    public void setPos(int x,int y){
	    	this.currentX=x;
	    	this.currentY=y;
	    	}
	    
	    public boolean isValidQ(){
	     	if ((currentX>=0)&&(currentX<8)&&(currentY>=0)&&(currentY<8)){
	    	  
	    	  if ((!this.isSetXY())&&((!qsign)&&(!q[currentX][currentY].isBlocked())||(q[currentX][currentY].isSigned()))){
	    	  
	if (mpresa){
		
		if ((currentX==mpX)&&(currentY==mpY)) return true;
		else return false;
		
		}
	    	  
	    	  if (q[currentX][currentY].GetPCol()==state) 
	    	        return true;}else{
	         
	          if (this.isValidMove()) 
	         	    return true;}
	         }
	   	return false;         
	    	} 
	    
	    
	    } 